<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Plugins Docs Module: device</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Plugins Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-data.html">data</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-client.html">client</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-time.html">time</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-twilio.html">twilio</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton-Liveset.html">ableton~Liveset</a></li><li><a href="module-control-SessionControl.html">control~SessionControl</a></li><li><a href="module-d-pro-Show.html">d-pro~Show</a></li><li><a href="module-data-Data.html">data~Data</a></li><li><a href="module-data-CollectionAPI.html">data~CollectionAPI</a></li><li><a href="module-device-Device.html">device~Device</a></li><li><a href="module-device-UDPdevice.html">device~UDPdevice</a></li><li><a href="module-device-OSCdevice.html">device~OSCdevice</a></li><li><a href="module-device-TCPdevice.html">device~TCPdevice</a></li><li><a href="module-device-Webdevice.html">device~Webdevice</a></li><li><a href="module-device-Serialdevice.html">device~Serialdevice</a></li><li><a href="module-device-Mididevice.html">device~Mididevice</a></li><li><a href="module-logic-Logic.html">logic~Logic</a></li><li><a href="module-logic-Condition.html">logic~Condition</a></li><li><a href="module-logic-Listener.html">logic~Listener</a></li><li><a href="module-logic-PEventListener.html">logic~PEventListener</a></li><li><a href="Messenger.html">Messenger</a></li><li><a href="Conversation.html">Conversation</a></li><li><a href="Agent.html">Agent</a></li><li><a href="module-plugin-Plugin.html">plugin~Plugin</a></li><li><a href="module-plugin-Collection.html">plugin~Collection</a></li><li><a href="module-plugin-Item.html">plugin~Item</a></li><li><a href="module-client-Agent.html">client~Agent</a></li><li><a href="module-client-Client.html">client~Client</a></li><li><a href="module-client-Bot.html">client~Bot</a></li><li><a href="module-telegram-Telegram.html">telegram~Telegram</a></li><li><a href="module-telegram-Conversation.html">telegram~Conversation</a></li><li><a href="module-telegram-Edit.html">telegram~Edit</a></li><li><a href="module-telegram-Message.html">telegram~Message</a></li><li><a href="module-phone-Phone.html">phone~Phone</a></li><li><a href="module-twilio-Switchboard.html">twilio~Switchboard</a></li><li><a href="module-twilio-SmsIn.html">twilio~SmsIn</a></li><li><a href="module-twilio-Call.html">twilio~Call</a></li><li><a href="module-twilio-CallIn.html">twilio~CallIn</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-8">
	
		<div id="main">
			

	<h1 class="page-title">Module: device</h1>
<section>

<header>
    
</header>


<article>
    <div class="container-overview">
    
        
            <div class="description"><p>Diverse Types of Device connectors</p></div>
        

        
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	
	<dt class="tag-copyright method-doc-label method-doc-details-label">Copyright:</dt>
	<dd class="tag-copyright">
		<ul class="dummy">
			<li>Lasse Marburg 2020</li>
		</ul>
	</dd>
	

	
	<dt class="tag-license method-doc-label method-doc-details-label">License:</dt>
	<dd class="tag-license">
		<ul class="dummy">
			<li>GPLv3</li>
		</ul>
	</dd>
	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="devices_device.js.html">devices/device.js</a>,
				 <a href="devices_device.js.html#sunlight-1-line-1">line 1</a>
			</li>
		</ul>
	</dd>
	

	

	

	
	<dt class="tag-todo method-doc-label method-doc-details-label">To Do:</dt>
	<dd class="tag-todo">
		<ul>
			<li>add stencils and stencils collection like in the old days. See editor.js</li>
			</ul>
	</dd>
	
</dl>


        
    
    </div>

    

    
        <h3 class="subsection-title">Requires</h3>

        <ul>
            <li>module:medley</li>
        
            <li>module:node-midi</li>
        
            <li>module:serialport</li>
        
            <li>module:net</li>
        
            <li>module:request</li>
        
            <li>module:dgram</li>
        
            <li>module:json5</li>
        </ul>
    

    
        <h3 class="subsection-title">Classes</h3>

        <dl>
            <dt><a href="module-device-Device.html">Device</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-UDPdevice.html">UDPdevice</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-OSCdevice.html">OSCdevice</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-TCPdevice.html">TCPdevice</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-Webdevice.html">Webdevice</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-Serialdevice.html">Serialdevice</a></dt>
            <dd></dd>
        
            <dt><a href="module-device-Mididevice.html">Mididevice</a></dt>
            <dd></dd>
        </dl>
    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        <dl>
            
<hr>
<dt>
    <h4 class="name" id="~activateMidi"><span class="type-signature">&lt;inner> </span>activateMidi()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>midi makes trouble on some machines so it needs to be activated manually</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="devices_device.js.html">devices/device.js</a>,
				 <a href="devices_device.js.html#sunlight-1-line-50">line 50</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="~setVirtualMidiPort"><span class="type-signature">&lt;inner> </span>setVirtualMidiPort(vmp)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>define a name for the virtual midi in and out ports</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>vmp</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name for virtual midi port</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="devices_device.js.html">devices/device.js</a>,
				 <a href="devices_device.js.html#sunlight-1-line-72">line 72</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="~getPorts"><span class="type-signature">&lt;inner> </span>getPorts(game)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>enlist all available port names. (Serial, Midi)<br>prepend a possible virtual midi port based on game name</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>game</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of game that is requesting ports</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="devices_device.js.html">devices/device.js</a>,
				 <a href="devices_device.js.html#sunlight-1-line-84">line 84</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>object with array for each serial and midi portnames. Arrays are empty [] if no valid pors are found</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="~getDevice"><span class="type-signature">&lt;inner> </span>getDevice(data, db, app, game_event)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>create and return device based on interface as specified in device settings<br>defaults to device collection for data storage</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>data set the device will be based on</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>db</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>interface to Database</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>app</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>express app to allow http requests and routing for webdevice</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>game_event</code></td>
            

            <td class="type">
            
                
<span class="param-type">EventEmitter</span>



            
            </td>

            

            

            <td class="description last"><p>event emitter that originated in game class instance</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="devices_device.js.html">devices/device.js</a>,
				 <a href="devices_device.js.html#sunlight-1-line-135">line 135</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>instance of one of the device classes</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Device</span>



    </dd>
</dl>


        

    
</dd>

        </dl>
    

    

    
</article>

</section>




		</div>
	</div>

	<div class="clearfix"></div>

	
		<div class="col-md-3">
			<div id="toc" class="col-md-3 hidden-xs hidden-sm hidden-md"></div>
		</div>
	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a>
	
		on Mon Jun 8th 2020
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>